
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <dbus/dbus.h>
#include <dbus/dbus-glib.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <libhal.h>
#include <unistd.h>

#include <sys/stat.h> //для автоопределения ФМ

#include "tray.h"

#define ICON_PATH ICON_DIR "/tray_eject_plus/"
#define MEDIA_DIR "/media/"
//#define FILE_BROWSER "nautilus" //убрал см. fileman

/* Originally based on wmvolman by Sir Raorn */


GHashTable *dev; //хеш таблица
GtkWidget *menu, *item, *sep;
GtkWidget *dialog, *msg, *dialog2, *msg2;
GtkStatusIcon *icon;

int count; //смотрированных
int countotal; //всего

char fileman[256]; //название файлового менеджера

GList* fstabdrive=NULL;

int usefloppy=-999;
char floppymp[256]; //точка монтирования флоппика
GtkWidget *fdsubm, *fdsub, *fdimg, *fditem, *fditem_i, *fditem_content, *fditem_c_i, *fditem_mount, *fditem_m_i; //для флоппика

//структура
struct mdev {
	GtkWidget *item;
	GtkWidget *item_mount;
	GtkWidget *item_content;
	char *mountpoint;
	//доп. данные
	char *label;
	char *blockdev;
	int size;
	int mount;
	//добавил для субменю
	GtkWidget *submenu;
	GtkWidget *submenuitem;
	GtkWidget *img;
	GtkWidget *item_i;
	GtkWidget *item_m_i;
	GtkWidget *item_c_i;
};

//+++++++ ф-я подсчета count  update_status->update_count
void update_count(gpointer key, gpointer value, gpointer user_data)
{
    	struct mdev *m = value;
    	if (m->mount==1) count++;
}

// ++++++++++++++ ф-я статус
void update_status()
{
	//подсчет
	countotal=(int) g_hash_table_size(dev);
	
	count=0;
	if (countotal>0){ 
	    g_hash_table_foreach(dev, (GHFunc)update_count, "ok");
	}

//#if 0
	if (count) {
		//gtk_widget_show(sep);
		//gtk_widget_set_sensitive(item, TRUE);
		gtk_status_icon_set_from_file(icon, ICON_PATH "dev1.png");
	} else {
		//gtk_widget_hide(sep);
		//gtk_widget_set_sensitive(item, FALSE);
		gtk_status_icon_set_from_file(icon, ICON_PATH "dev0.png");
	}
//#endif

	char txt[100];
	
	snprintf(txt, 100, "TrayEject+\nMount	%i\nUnMount	%i", count, countotal-count);
	gtk_status_icon_set_tooltip(icon, txt);

	//countotal=1;
	if (usefloppy>-1) countotal++;
	gtk_status_icon_set_visible(icon, !!countotal);
	//gtk_status_icon_set_visible(icon, !!count);
}

//+++++++++++ убираем ключ key_destroy
void key_destroy(gpointer data)
{
	free(data);
}

//+++++++++++ убираем запись main->value_destroy
void value_destroy(gpointer data)
{
	struct mdev *m = data;

	gtk_widget_destroy(m->img);
	gtk_widget_destroy(m->item_i);
	gtk_widget_destroy(m->item_m_i);
	gtk_widget_destroy(m->item_c_i);
	gtk_widget_destroy(m->item);
	gtk_widget_destroy(m->item_mount);
	gtk_widget_destroy(m->item_content);
	gtk_widget_destroy(m->submenu);
	gtk_widget_destroy(m->submenuitem);
	free(m);
//	count--;
}

static int res = 0;

// +++++++++++++ выполнение размонтирования eject->eject_device
static void eject_device(gpointer key, gpointer value, gpointer user_data)
{
	struct mdev *m = value;

	if (value) {
		char cmd[256];
            	char *mountcmd;
		if (!access("/usr/bin/halevt-umount", X_OK))
			mountcmd = "halevt-umount";
		else if (!access("/usr/bin/pumount", X_OK))
			mountcmd = "pumount";
		else
			mountcmd = "umount";
		snprintf(cmd, 256, "%s \"%s\"", mountcmd, m->mountpoint);
		res |= system(cmd);
	}
}

//+++++++++++++++ размонтирование - выбор в меню add_mount->eject
static void eject(GtkWidget *widget, gpointer data)
{
	res = 0;

	if (data) {
		eject_device(NULL, data, NULL);
	} else {
		g_hash_table_foreach(dev, eject_device, NULL);
	}

	if (res) {
        	gtk_widget_show(dialog);
		gtk_dialog_run(GTK_DIALOG(dialog));
        	gtk_widget_hide(dialog);
	}
}

//+++++++++++ ф-я просмотр access_->access_device
static void access_device(gpointer key, gpointer value, gpointer user_data)
{
	int pid=1;
	struct mdev *m = value;
	char cmd[256];
	
	if (value) {
	       pid = fork();
	       if (!pid) {
		   snprintf(cmd, 256, "%s%s", fileman, m->mountpoint);
g_print("go|%s|\n", cmd);
		   res |= system(cmd);
		   exit(1);
	       }
	}
}

//+++++++++++++ выбрали просмотр девайса add_mount->access_
static void access_(GtkWidget *widget, gpointer data)
{
       if (data) {
               access_device(NULL, data, NULL);
       }
}

//+++++++++++ ф-я просмотр mount_->mount_device
static void mount_device(gpointer key, gpointer value, gpointer user_data)
{
	struct mdev *m = value;

	res=0;

	if (value) {
		char cmd[256];
            	char *mountcmd;
		if (!access("/usr/bin/halevt-mount", X_OK))
			mountcmd = "halevt-mount";
		else if (!access("/usr/bin/pmount", X_OK))
			mountcmd = "pmount";
		else
			mountcmd = "mount";
		
		snprintf(cmd, 256, "%s \"%s\"", mountcmd, m->blockdev);
		res |= system(cmd);
	}

	if (res) {
        	gtk_widget_show(dialog2);
		gtk_dialog_run(GTK_DIALOG(dialog2));
        	gtk_widget_hide(dialog2);
	}

}


//+++++++++++++ выбрали просмотр девайса add_mount->mount_
static void mount_(GtkWidget *widget, gpointer data)
{
       if (data) {
               mount_device(NULL, data, NULL);
       }
}


//+++++++++++++++++++++++++  hal_property_added->add_mount
static void add_mount(const char *udi, char *mountpoint, char *label, int size, int type, int devmount, char *blockdev)
{
	struct mdev *m;
	char *u, txt[80], lab[20];

	if ((m = malloc(sizeof(*m))) == NULL) {
		perror("malloc");
		return;
	}

	if ((m->mountpoint = strdup(mountpoint)) == NULL) {
		free(m);
		return;
	}

	if ((m->blockdev = strdup(blockdev)) == NULL) {
		free(m);
		free(m->mountpoint);
		return;
	}

	if ((u = strdup(udi)) == NULL) {
		free(m);
		free(m->mountpoint);
		free(m->blockdev);
		return;
	}

	char myimg[1024];
     if (devmount==1) {
	if ( type==0 ) snprintf(myimg, 1024, "%sblockdevice.png", ICON_PATH);
	if ( type==1 ) snprintf(myimg, 1024, "%ssd_mmc_mount.png", ICON_PATH);
	if ( type==2 ) snprintf(myimg, 1024, "%sipod_mount.png", ICON_PATH);
	if ( type==3 ) snprintf(myimg, 1024, "%susbpendrive_mount.png", ICON_PATH);
	if ( type==4 ) snprintf(myimg, 1024, "%scdrom_mount.png", ICON_PATH);
	if ( type==5 ) snprintf(myimg, 1024, "%sfloppydrive_mount.png", ICON_PATH);
	if ( type==6 ) snprintf(myimg, 1024, "%susbdrive_mount.png", ICON_PATH);
     }else{
	if ( type==0 ) snprintf(myimg, 1024, "%sblockdevice.png", ICON_PATH);
	if ( type==1 ) snprintf(myimg, 1024, "%ssd_mmc_unmount.png", ICON_PATH);
	if ( type==2 ) snprintf(myimg, 1024, "%sipod_unmount.png", ICON_PATH);
	if ( type==3 ) snprintf(myimg, 1024, "%susbpendrive_unmount.png", ICON_PATH);
	if ( type==4 ) snprintf(myimg, 1024, "%scdrom_unmount.png", ICON_PATH);
	if ( type==5 ) snprintf(myimg, 1024, "%sfloppydrive_unmount.png", ICON_PATH);
	if ( type==6 ) snprintf(myimg, 1024, "%susbdrive_unmount.png", ICON_PATH);
     }

//g_print("i|%s|\n", myimg);

	//SUB item и submenu

    snprintf(lab, 20, "%s", label);
    if (devmount==1) {
	snprintf(txt, 80, "%s \"%s...\" (%iMb)",mountpoint + strlen(MEDIA_DIR), lab, size);
    } else {
	snprintf(txt, 80, "\"%s\" (%iMb)",lab, size);    
    }

	m->submenu = gtk_menu_new();
	//m->submenuitem =  gtk_menu_item_new_with_label(txt);
	m->submenuitem =  gtk_image_menu_item_new_with_label(txt);
	m->img = gtk_image_new_from_file(myimg);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->submenuitem), m->img);
	gtk_widget_show(m->submenuitem);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(m->submenuitem), m->submenu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), m->submenuitem);


	//UMOUNT

	snprintf(txt, 80, "%s %s%s", _("Safely remove"), MEDIA_DIR,
					mountpoint + strlen(MEDIA_DIR));

	//m->item = gtk_menu_item_new_with_label(txt);
	m->item = gtk_image_menu_item_new_with_label(txt);
	m->item_i = gtk_image_new_from_file(ICON_PATH "unmount.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->item), m->item_i);
        gtk_widget_show(m->item);
        gtk_menu_shell_append(GTK_MENU_SHELL(m->submenu), m->item);
	g_signal_connect(G_OBJECT(m->item), "activate", G_CALLBACK(eject), m);

	//VIEW

        snprintf(txt, 80, "%s %s%s", _("Access content on"), MEDIA_DIR,
		                        mountpoint + strlen(MEDIA_DIR));

        //m->item_content = gtk_menu_item_new_with_label(txt);
        m->item_content =gtk_image_menu_item_new_with_label(txt);
	m->item_c_i = gtk_image_new_from_file(ICON_PATH "look.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->item_content), m->item_c_i);
        gtk_widget_show(m->item_content);
        gtk_menu_shell_append(GTK_MENU_SHELL(m->submenu), m->item_content);
        g_signal_connect(G_OBJECT(m->item_content), "activate", G_CALLBACK(access_), m);

	//MOUNT

	snprintf(txt, 80, "%s", _("Mount"));

	//m->item_mount = gtk_menu_item_new_with_label(txt);
	m->item_mount = gtk_image_menu_item_new_with_label(txt);
	m->item_m_i = gtk_image_new_from_file(ICON_PATH "mount.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->item_mount), m->item_m_i);
        gtk_widget_show(m->item_mount);
        gtk_menu_shell_append(GTK_MENU_SHELL(m->submenu), m->item_mount);
	g_signal_connect(G_OBJECT(m->item_mount), "activate", G_CALLBACK(mount_), m);


     //добиваем параметры
     if ( (m->label = strdup(lab))==NULL ) m->label = strdup("");
     m->size=size;


     if (devmount==1) {
	//count++;
	//gtk_widget_set_sensitive(m->item, TRUE); //можно
	m->mount=1;
	gtk_widget_show(m->item); //можно
	gtk_widget_show(m->item_content); //можно
	gtk_widget_hide(m->item_mount); //запрет
     } else {
	m->mount=0;
	gtk_widget_hide(m->item); //можно
	gtk_widget_hide(m->item_content); //можно
	gtk_widget_show(m->item_mount); //запрет
     }

	g_hash_table_insert(dev, u, m);
}


//++++++++++++++ удалить девайс из меню  hal_property_removed->remove_mount
static void remove_mount(const char *udi)
{
	g_hash_table_remove(dev, udi);
}



//++++++++++++++++ main->popup
static void popup()
{
g_print("counttotal|%i|\n", countotal);
	//показать меню если нажата кнопка 3 мышки
	if (countotal>0){ 
	    gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, 3, gtk_get_current_event_time());
	}
}


//+++++++++++++++++++++init_hal->hal_added
static void hal_added(LibHalContext *ctx, const char *udi)
{

			//точка монтирования
			char *mountpoint = libhal_device_get_property_string(ctx, udi, "volume.mount_point", NULL);
			

			//UUID
			char *devid = libhal_device_get_property_string(ctx, udi, "volume.uuid", NULL);

			//лейбл
			char *label = libhal_device_get_property_string(ctx, udi, "volume.label", NULL);
			
			//размер
			dbus_uint64_t size64 = libhal_device_get_property_uint64(ctx, udi, "volume.size", NULL);
			size64=size64/(1024*1024);
			int size = (int) size64;

g_print("\nu|%s| - modif\n", udi);

			//тип
			char *storage;
			int type=0; //по умолчанию
			int allfine=1;
			char *ctype=0;
		      if (   ( storage=libhal_device_get_property_string(ctx, udi, "block.storage_device", NULL) )   ) {
			if ( strcmp(storage, "") != 0 ){
			  if (   (ctype=libhal_device_get_property_string(ctx, storage, "storage.drive_type", NULL) )  ){
				if ( strcmp(ctype, "sd_mmc") == 0 ) type=1;
				if ( strcmp(ctype, "portable_audio_player") == 0 ) type=2;
				if ( strcmp(ctype, "usb") == 0 ) type=3;
				if ( strcmp(ctype, "disk") == 0 ) type=3;
				if ( strcmp(ctype, "cdrom") == 0  ) type=4;
				if ( strcmp(ctype, "floppy") == 0  ) type=5;
				//if (type==3 && size>70000 )  type=6; //usb HDD
				if (type==3 && size>18000 )  type=6; //usb HDD
			  }else{
			     allfine=0;
			  }

			  //Для не флешек и сд размер по другому
			  char *cat = libhal_device_get_property_string(ctx, storage, "info.category", NULL);
			  if ( strcmp(cat, "storage")!=0  ){
			      size64 = libhal_device_get_property_uint64(ctx, storage, "storage.size", NULL);
			      size64=size64/(1024*1024);
			      size = (int) size64;
			  }
			}
		     } else {
		        allfine=0;
		     }//if ( storage=l

			//файловая система

			char *fsystem;
		     if (  ( fsystem=libhal_device_get_property_string(ctx, udi, "volume.fstype", NULL) )  ){
			if ( strcmp(fsystem, "") != 0 ){
			  if ( strcmp(fsystem, "swap") == 0 ) allfine=0; //swap не нужен
			} else {
			    allfine=0;
			}
		     } else {
		        allfine=0;
		     }//if ( fsystem=libh
			
			
			int devmount=0;
			if (libhal_device_get_property_bool(ctx, udi, "volume.is_mounted", NULL)) {
			 devmount=2; //диски уже смонтированные - но не в MEDIA_DIR - нам не нужны
			 if (!strncmp(MEDIA_DIR, mountpoint, strlen(MEDIA_DIR))) {
			    devmount=1;
			 }
			}

			//определим как в dev устройство видит система - а то как присоединять ?
			char *blockdev;
			if (  !( blockdev=libhal_device_get_property_string(ctx, udi, "block.device", NULL) )  ) {
		    	    allfine=0;
		    	}
		    	if (sizeof(blockdev)==0) allfine=0;

			//проверим что не в листе из FSTAB по устройству
			int iii=0;
			char m1[100], m2[100];
			snprintf(m1, 100, "%s", blockdev);
			for (iii=0; iii<g_list_length(fstabdrive); iii++){
			    snprintf(m2, 100, "%s", (char *) g_list_nth_data(fstabdrive, iii) );
			    if ( strcmp(m1, m2) == 0 ) {  //в листе
			     allfine=0;
g_print("F_by_dev |%s|\n", m1);
			    }
			}
			//проверим что не в листе из FSTAB по UUID
			snprintf(m1, 100, "%s", devid);
			for (iii=0; iii<g_list_length(fstabdrive); iii++){
			    snprintf(m2, 100, "%s", (char *) g_list_nth_data(fstabdrive, iii) );
			    if ( strcmp(m1, m2) == 0 ) {  //в листе
			     allfine=0;
g_print("F_by_UUID |%s|\n", m1);
			    }
			}




g_print("stor=%s|ctupe=%s|type=%i|dm=%i|mp=%s|fs=%s|bd=%s|uuid=%s\n", storage, ctype, type, devmount,mountpoint, fsystem, blockdev, devid);

			if ( devmount<2 && allfine==1 ) {
			    add_mount(udi, mountpoint, label, size, type, devmount, blockdev);
g_print("ADD\n");
			}


			if (mountpoint)
				libhal_free_string(mountpoint);

		if (countotal!=-999) update_status();
	
}

//+++++++++++++++++++++init_hal->hal_removed
static void hal_removed(LibHalContext *ctx, const char *udi)
{
    remove_mount(udi);
    update_status();
}

//+++++++++++++++++++++init_hal->hal_property_modified
static void hal_property_modified(LibHalContext *ctx, const char *udi,
	  const char *key, dbus_bool_t is_removed, dbus_bool_t is_added)
{

    if (!strcmp(key, "volume.is_mounted")) {
	//точка монтирования
    	char *mountpoint = libhal_device_get_property_string(ctx, udi, "volume.mount_point", NULL);

	int devmount=0;
	if (libhal_device_get_property_bool(ctx, udi, "volume.is_mounted", NULL)) {
		 devmount=2; //диски уже смонтированные - но не в MEDIA_DIR - нам не нужны
		 if (!strncmp(MEDIA_DIR, mountpoint, strlen(MEDIA_DIR))) {
			    devmount=1;
		 }
	}
	
	    //ищем а есть ли девайс у нас в листе...
	if (devmount<2){
	    gpointer data;
	    if ( ( data=g_hash_table_lookup(dev, udi) ) !=NULL){
	        //есть
	        struct mdev *m=data;
	        char lab[20];
	        snprintf(lab, 20, "%s", m->label);
	        int size=m->size;

	        char txt[80];
		if (devmount==1) {
		    snprintf(txt, 80, "%s \"%s...\" (%iMb)",mountpoint + strlen(MEDIA_DIR), lab, size);
		} else {
		    snprintf(txt, 80, "\"%s\" (%iMb)",lab, size);    
		}
		
		gtk_menu_item_set_label((GtkMenuItem *) m->submenuitem, txt);

		snprintf(txt, 80, "%s %s%s", _("Safely remove"), MEDIA_DIR, mountpoint + strlen(MEDIA_DIR));
		gtk_menu_item_set_label((GtkMenuItem *) m->item, txt);

    		snprintf(txt, 80, "%s %s%s", _("Access content on"), MEDIA_DIR,mountpoint + strlen(MEDIA_DIR));
		gtk_menu_item_set_label((GtkMenuItem *) m->item_content, txt);

		snprintf(txt, 80, "%s", _("Mount"));
		gtk_menu_item_set_label((GtkMenuItem *) m->item_mount, txt);

		m->mountpoint = strdup(mountpoint);
	        if (devmount==1) {
			//count++;
			m->mount=1;
			gtk_widget_show(m->item); //можно
			gtk_widget_show(m->item_content); //можно
			gtk_widget_hide(m->item_mount); //запрет
    		} else {
			//count--;
			m->mount=0;
			gtk_widget_hide(m->item); //можно
			gtk_widget_hide(m->item_content); //можно
			gtk_widget_show(m->item_mount); //запрет
    		}
	    }//if ( ( m=g_hash_table_lo
	}
	update_status();
    }
}


//+++++++++++++++++  access__floppy -> mftrue
static int mftrue(void){
	//если возвращаю 0 - то смонтировано
	int okok=1;

	FILE *myfile;
	char string[300];
	char *temp;

	if ( ( myfile=fopen("/etc/mtab", "r") )!=(FILE *)0  ){
	    while ( ( fgets(string, 299, myfile) )!=(char *)0  ){
		temp=strtok(string, " ");
		while (temp!=NULL){
			if ( strcmp(temp, floppymp) == 0 ){
				okok=0;
			}
			temp=strtok(NULL, " ");
			if (okok==0) break;
		}
		if (okok==0) break;
	    }//while
	    fclose(myfile);		
	}


	return okok;
}


//+++++++++++++++++  floppymenu ->eject__floppy
static void eject__floppy(void)
{

		res=0;
	if (mftrue()==0){
		char cmd[256];
            	char *mountcmd;
		if (!access("/usr/bin/halevt-umount", X_OK))
			mountcmd = "halevt-umount";
		else if (!access("/usr/bin/pumount", X_OK))
			mountcmd = "pumount";
		else
			mountcmd = "umount";
		snprintf(cmd, 256, "%s \"%s%i\"", mountcmd, "/dev/fd", usefloppy);
		res |= system(cmd);

		if (res) {
        	gtk_widget_show(dialog);
		gtk_dialog_run(GTK_DIALOG(dialog));
        	gtk_widget_hide(dialog);
		}
	}

}


//+++++++++++++++++  floppymenu -> mount_floppy
static void mount_floppy(void)
{

		res=0;
	if (mftrue()!=0){
		char cmd[256];
            	char *mountcmd;
		if (!access("/usr/bin/halevt-mount", X_OK))
			mountcmd = "halevt-mount";
		else if (!access("/usr/bin/pmount", X_OK))
			mountcmd = "pmount";
		else
			mountcmd = "mount";
		
		snprintf(cmd, 256, "%s \"%s\"", mountcmd, floppymp);
		res |= system(cmd);

		if (res) {
        	gtk_widget_show(dialog2);
		gtk_dialog_run(GTK_DIALOG(dialog2));
        	gtk_widget_hide(dialog2);
		}
	}

}

//+++++++++++++++++  floppymenu -> access__floppy
static void access__floppy(void)
{

	int pid=0;
	char cmd[256];

	if (mftrue()==0){
		pid=1;
	} else {
		mount_floppy();
		if (mftrue()==0){
			pid=1;
		}
	}

	if ( pid==1 ){	
	       pid = fork();
	       if (!pid) {
		   snprintf(cmd, 256, "%s%s", fileman, floppymp);
g_print("go_fl|%s|\n", cmd);
		   res |= system(cmd);
		   exit(1);
       		}
	}

}

//+++++++++++++ init_hal->floppymenu выполняется один раз
static void floppymenu(void)
{

	char myimg[1024];

	fdsubm= gtk_menu_new();
	fdsub=gtk_image_menu_item_new_with_label( _("Floppy Drive"));
	snprintf(myimg, 1024, "%sfloppydrive_mount.png", ICON_PATH);
	fdimg = gtk_image_new_from_file(myimg);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(fdsub), fdimg);
	gtk_widget_show(fdsub);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(fdsub), fdsubm);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), fdsub);

	sep = gtk_separator_menu_item_new();
	gtk_widget_show(sep);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep);


	//UMOUNT

	char txt[80];
	snprintf(txt, 80, "%s %s%i", _("Safely remove"), "/dev/fd", usefloppy );


	fditem = gtk_image_menu_item_new_with_label(txt);
	fditem_i = gtk_image_new_from_file(ICON_PATH "unmount.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(fditem), fditem_i);
        gtk_widget_show(fditem);
        gtk_menu_shell_append(GTK_MENU_SHELL(fdsubm), fditem);
	g_signal_connect(G_OBJECT(fditem), "activate", G_CALLBACK(eject__floppy), NULL);

	//VIEW

        snprintf(txt, 80, "%s %s%i", _("Access content on"), "/dev/fd", usefloppy );

        fditem_content =gtk_image_menu_item_new_with_label(txt);
	fditem_c_i = gtk_image_new_from_file(ICON_PATH "look.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(fditem_content), fditem_c_i);
        gtk_widget_show(fditem_content);
        gtk_menu_shell_append(GTK_MENU_SHELL(fdsubm), fditem_content);
        g_signal_connect(G_OBJECT(fditem_content), "activate", G_CALLBACK(access__floppy), NULL);

	//MOUNT

	snprintf(txt, 80, "%s", _("Mount"));

	fditem_mount = gtk_image_menu_item_new_with_label(txt);
	fditem_m_i = gtk_image_new_from_file(ICON_PATH "mount.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(fditem_mount), fditem_m_i);
        gtk_widget_show(fditem_mount);
        gtk_menu_shell_append(GTK_MENU_SHELL(fdsubm), fditem_mount);
	g_signal_connect(G_OBJECT(fditem_mount), "activate", G_CALLBACK(mount_floppy), NULL);
}



//+++++++++++++ main->init_hal выполняется один раз
static int init_hal(void)
{

	LibHalContext *ctx;
	DBusError error;
	DBusConnection *dbus_connection;
	char **devices, **volumes;
	int i, num;

	if (!(ctx = libhal_ctx_new())) { //новое соединение с hal
		fprintf(stderr, "can't initialize\n");
		return -1;
	}

	dbus_error_init(&error);
	dbus_connection = dbus_bus_get(DBUS_BUS_SYSTEM, &error); //доступ к dbus

	if (dbus_error_is_set(&error)) {
		fprintf(stderr, "%s\n", error.message);
		dbus_error_free(&error);
		return -1;
	}

	dbus_connection_setup_with_g_main(dbus_connection, NULL); //таймаута нету ?
	libhal_ctx_set_dbus_connection(ctx, dbus_connection); //связываем ?
	libhal_ctx_set_device_added(ctx, hal_added); //вызываем при добавлении девайса
	libhal_ctx_set_device_removed(ctx, hal_removed); //вызываем при удалении девайса
	libhal_ctx_set_device_property_modified(ctx, hal_property_modified); //вызываем при изменениях в жизни девайса hal_property_modified

	if (!libhal_device_property_watch_all(ctx, &error)) { //приглядывать за всеми
		fprintf(stderr, "%s\n", error.message);
		dbus_error_free(&error);
		libhal_ctx_free(ctx);
		return -1;
	}

	if (!libhal_ctx_init(ctx, &error)) { //соединяем наше соединение
		fprintf(stderr, "%s\n", error.message);
		dbus_error_free(&error);
		libhal_ctx_free(ctx);
		return -1;
	}

	if (!(devices = libhal_get_all_devices(ctx, &num, &error))) { //получим список девайсов - проверка работает ли ?
		fprintf(stderr, "%s\n", error.message);
		dbus_error_free(&error);
		libhal_ctx_shutdown(ctx, NULL);
		libhal_ctx_free(ctx);
		return -1;
	}

	libhal_free_string_array(devices); //освобождаем

	volumes = libhal_find_device_by_capability(ctx, "volume", &num, &error); //получить список девайсов с характенистикой "volume" и их кол-во
	
	if (dbus_error_is_set(&error)) {
		printf("can't find volume devices: %s\n", error.message);
		dbus_error_free(&error);
		libhal_ctx_shutdown(ctx, NULL);
		libhal_ctx_free(ctx);
		return -1;
	}

	for (i = 0; i < num; i++) {
		char *udi = volumes[i];

g_print("udi|%s| -- ", udi);
		//устройство можно примонтировать
		if ( libhal_device_property_exists(ctx, udi, "volume.is_mounted", NULL) ){
		   //if ( libhal_device_get_property_bool(ctx, udi, "volume.is_mounted", NULL) )
		   //{
g_print("ok");
			hal_added(ctx, udi); //вызываем ф-ю
			//hal_property_modified(ctx, udi, "volume.mount_point", FALSE, FALSE); //вызываем ф-ю
		   //}
		}
g_print("\n");
	}

	if (usefloppy>-1) {
	    //у нас есть флопик %)
	    floppymenu();
g_print("floppy=/dev/fd%i\n", usefloppy);
	}	

	countotal=0;
	update_status();


	libhal_free_string_array(volumes); //освобождаем

	return 0;
}


//+++++++++++++ main->readfstab выполняется один раз
static void readfstab(void)
{
	//для начала считаем содержимое /etc/fstab в fstabdrive
	
	//g_print("%i\n", g_list_length(fstabdrive));
	char string[300], strmp[300], strmp2[300];
	int myi=0, myz=0, find=0, fd=0;
	FILE *myfile;
	strcpy(floppymp,"");

	if ( ( myfile=fopen("/etc/fstab", "r") )!=(FILE *)0  ){
	    while ( ( fgets(string, 299, myfile) )!=(char *)0  ){
		//разбор строки

		find=0;
		myz=0;
		strcpy(strmp,"");
		fd=0;
		for (myi=0; myi<298; myi++){
		  if ( find ==0 ){
		    if ( (char) string[myi]==35 ) { // # это комментарий
			    find=999; 
		    }

		    if (myi+20<298){

			if ( usefloppy==-999 && (char) string[myi]==47 && (char) string[myi+1]==100 && (char) string[myi+2]==101 && (char) string[myi+3]==118 && (char) string[myi+4]==47  && (char) string[myi+5]==102  && (char) string[myi+6]==100  ){ // /dev/fd //ищем флоппик

			    if ( (char) string[myi+7]==48 ) { usefloppy=0; fd=1;};
			    if ( (char) string[myi+7]==49 ) { usefloppy=1; fd=1;};
			    if ( (char) string[myi+7]==50 ) { usefloppy=2; fd=1;};
			    //не думаю что может быть fd3 и выше...

			    find=1;
			}else if ( (char) string[myi]==47 && (char) string[myi+1]==100 && (char) string[myi+2]==101 && (char) string[myi+3]==118 && (char) string[myi+4]==47  ){ // /dev/

			  //проверка а вдруг СД ром
			  if ( (char) string[myi+8]==32 || (char) string[myi+8]==9 ) {  // это не  hdcX это hdc т.е. не раздел а устройство
				    find=999; //сдром
			  } else if ( (char) string[myi+5]==104 && (char) string[myi+6]==100 ){ // hd
				    find=1;
				    snprintf(strmp, 300, "%s", "/dev/hd");
				    myi=myi+7;
				    myz=7;
			  } else if ( (char) string[myi+5]==115 && (char) string[myi+6]==100 ){  // sd
				    find=1;
				    snprintf(strmp, 300, "%s", "/dev/sd");
				    myi=myi+7;
				    myz=7;
			  }
			}else if ( (char) string[myi]==85 && (char) string[myi+1]==85 && (char) string[myi+2]==73 && (char) string[myi+3]==68 ){ // UUID

				    find=1;
				    myi=myi+5; //еще знак =
				    myz=0;
			} else if ( (char) string[myi]==117 && (char) string[myi+1]==117 && (char) string[myi+2]==105 && (char) string[myi+3]==100 ){ // uuid

				    find=1; 
				    myi=myi+5; //еще знак =
				    myz=0;
			}
		    }
		  }//find==0


		  if (  find==1 && ( (char) string[myi]==32 ||  (char) string[myi]==9 )  ){ find=2;  }; //конец uuid или устройства

		  if ( find==1 ) {
			if (fd==0){ //если не флоппи
			    snprintf(strmp2, 300, "%s", strmp);
			    snprintf(strmp, 300, "%s%c", strmp2, string[myi]);
			    myz++;
			}
		  }
		  
		  //if ( find==1 ) find=2;
		  if ( find==2 && myi>5 && (  ( (char) string[myi-1]==32 && (char) string[myi]==47 ) || ( (char) string[myi-1]==9 && (char) string[myi]==47 )  ) ){ // {spase}/  или {таб}/
			    find=3; //нашли начало точки монтирования
		  }
		  
		  if ( find==3 && ( (char) string[myi]==32 || (char) string[myi]==9 ) ){
			    find=4; //нашли конец точки монтирования
		  }
		  
		  if ( find==3 ){ //ищем точку монтирования для флоппика
			if (fd==1){ //если флоппи
			    snprintf(strmp2, 300, "%s", strmp);
			    snprintf(strmp, 300, "%s%c", strmp2, string[myi]);
			    myz++;
			}
			    //ищим слово cdrom 
			    if (myz+5<298) {
				if ( (char) string[myi]==99 &&  (char) string[myi+1]==100  &&  (char) string[myi+2]==114  &&  (char) string[myi+3]==111  &&  (char) string[myi+4]==109  ) {find=999;}; //это cdrom
			    }
		  } //find==2

		  if ( find==4 &&  (char) string[myi]!=32 && (char) string[myi]!=9 ){
			    find=5; //нашли начало опций
		  }

		  if ( find==5 && ( (char) string[myi]==32 || (char) string[myi]==9 ) ){
			    find=6; //нашли конец опций
			    break; //выход
		  }

		  if ( find==5 && myi+3<298  ){
			//что там в опциях ? iso9 - выход
			if (  (char) string[myi]==105  &&  (char) string[myi+1]==115  &&  (char) string[myi+2]==111  &&  (char) string[myi+3]==57 )  {find=999;}
		  }

		  
		  if (  (char) string[myi]=='\0' ) { break;}; //приехали - символа нет.
		  if ( find==999){ break; }; //выход
		}//for
		if ( myz>0 && find==6 && fd==0){
g_print("dev_or_uuid=%s\n", strmp);
		    fstabdrive=g_list_append(fstabdrive, strndup(strmp, myz));
		}
		if (fd==1){
		  if ( myz>0 && find==6){
g_print("floppy_mp=%s\n", strmp);
		    snprintf(floppymp, 256, "%s", strmp);
		  }else{
		    usefloppy=-999;
		  }
		}
	    }//while
	    fclose(myfile);
	}
}




//MAIN ++++++++++++++++
int main(int argc, char **argv)
{
	bindtextdomain("tray_eject_plus", LOCALE_DIR);
        textdomain("tray_eject_plus");

	gtk_init(&argc, &argv);

	struct stat st;

	// читаем ключи по умолчанию файловый менеджер fileman = "nautilus --no-desktop"
	int zz;
	char oldfileman[256];
	if (argc > 1) {
	  for (zz = 1; zz < argc; zz++) {
	    sprintf(oldfileman,"%s", fileman);
	    sprintf(fileman,"%s%s ", oldfileman, argv[zz]);
	  }
	} else {
	  sprintf(fileman,"nautilus --no-desktop "); //def

	  if ( stat("/usr/bin/thunar", &st)==0 ) {
	    sprintf(fileman,"thunar ");
	  } else if ( stat("/usr/bin/pcmanfm2", &st)==0 ) {
	    sprintf(fileman,"pcmanfm2 ");
	  } else if ( stat("/usr/bin/pcmanfm", &st)==0 ) {
	    sprintf(fileman,"pcmanfm ");
	  }else if ( stat("/usr/local/bin/thunar", &st)==0 ) {
	    sprintf(fileman,"thunar ");
	  } else if ( stat("/usr/local/bin/pcmanfm2", &st)==0 ) {
	    sprintf(fileman,"pcmanfm2 ");
	  } else if ( stat("/usr/local/bin/pcmanfm", &st)==0 ) {
	    sprintf(fileman,"pcmanfm ");
	  }
	}

//g_print("fm|%s|\n", fileman);

	count = 0; //смонтированных
	countotal=-999; //всего (пока -999 для скорости)

	//создаем таблицу с ключами
	//key_destroy - вызывается при удалении ключа
	//value_destroy - вызывается при удалении значения (записи)
	dev = g_hash_table_new_full(g_str_hash, g_str_equal, key_destroy,
							value_destroy);

	icon = (GtkStatusIcon *) gtk_status_icon_new_from_file(ICON_PATH "dev1.png");

	update_status(); //ф-я

	menu = gtk_menu_new(); //меню


	usefloppy=-999;
	readfstab(); //читаем fstab
g_print("g_list %i\n", g_list_length(fstabdrive));

	//Не нужно - убираю
	//submenu = gtk_menu_new();
	//submenuitem =  gtk_menu_item_new_with_label("SUB");
	//gtk_widget_show(submenuitem);
	//gtk_menu_item_set_submenu(GTK_MENU_ITEM(submenuitem), submenu);
	//gtk_menu_shell_append(GTK_MENU_SHELL(menu), submenuitem);
	
	//item = gtk_menu_item_new_with_label(_("Safely remove all"));
	//gtk_widget_show(item);
	//gtk_menu_shell_append(GTK_MENU_SHELL(submenu), item);
	//g_signal_connect(G_OBJECT(item), "activate", G_CALLBACK(eject), NULL);

	

	//sep = gtk_separator_menu_item_new();
	//gtk_widget_show(sep);
	//gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep);

	g_signal_connect(G_OBJECT(icon), "popup-menu", G_CALLBACK(popup), NULL); //при нажатии на иконку вызвать popup

	//запуск init_hal или выход
	if (init_hal() < 0)
		return 1;

	//диалоги и месседжи
	dialog = gtk_dialog_new_with_buttons("Error", NULL,
			GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
			GTK_STOCK_OK, NULL);
	gtk_window_set_icon_from_file(GTK_WINDOW(dialog), ICON_PATH "error.png", NULL);

	msg = gtk_label_new(_("Unable to unmount this device. Some\napplication is likely to be using it.\nPlease close the offending application\nand try again."));
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), msg, TRUE, TRUE, 10);
        gtk_widget_show(msg);

	dialog2 = gtk_dialog_new_with_buttons("Error", NULL,
			GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
			GTK_STOCK_OK, NULL);
	gtk_window_set_icon_from_file(GTK_WINDOW(dialog2), ICON_PATH "error.png", NULL);

	msg2 = gtk_label_new(_("Unable to mount this device"));
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog2)->vbox), msg2, TRUE, TRUE, 10);
        gtk_widget_show(msg2);

	//пуск
	gtk_main();

	return 0;
}
